package rocks.zipcode.io.quiz3.arrays;

/**
 * @author leon on 09/12/2018.
 */
public class TicTacToe {
    String[][] board;

    public TicTacToe(String[][] board) {
        this.board = board;
    }
//
//    public TicTacToe() {
//        this(new String[3][3]);
//    }

    public String[] getRow(Integer value) {
        return board[value];
    }

    public String[] getColumn(Integer value) {
        String[] col = new String[board[0].length];
        for (int i = 0; i < board[0].length; i++) {
            col[i] = board[i][value];
        }
        return col;
    }

    public Boolean isRowHomogenous(Integer rowIndex) {
        String[] row = getRow(rowIndex);
        return getMatch(row);
    }

    public Boolean isColumnHomogeneous(Integer columnIndex) {
        String[] col = getColumn(columnIndex);
        return getMatch(col);
    }

    public Boolean isDiagonal1Homogeneous() {
        String[] diag = new String[board[0].length];
        for (int i = 0; i < board[0].length; i++) {
            diag[i] = board[i][i];
        }
        return getMatch(diag);
    }

    public Boolean isDiagonal2Homogeneous() {
        String[] diag = new String[board[0].length];
        int countDown = board[0].length-1;
        for (int i = 0; i < board[0].length; i++) {
            diag[i] = board[countDown][i];
            countDown--;
        }
        return getMatch(diag);
    }

    private Boolean getMatch(String[] line) {
        for (int i = 0; i < line.length - 1; i++) {
            if (line[i] != line[i + 1]) {
                return false;
            }
        }
        return true;
    }

    public String getWinner() {
        if (isDiagonal1Homogeneous()) {
            return board[0][0];
        }
        if (isDiagonal2Homogeneous()) {
            return board[2][0];
        }
        for (int i = 0; i < board[0].length; i++) {
            if (isColumnHomogeneous(i)) {
                return board[0][i];
            }
            if (isRowHomogenous(i)) {
                return board[i][0];
            }
        }
        return null;
    }
}
