package rocks.zipcode.io.quiz3.collections;

import rocks.zipcode.io.quiz3.objectorientation.enums.LabStatus;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author leon on 10/12/2018.
 */
public class Student {
    private Map<Lab, LabStatus> labStatusMap;

    public Student() {
        this(new HashMap<>());
    }

    public Student(Map<Lab, LabStatus> map) {
        this.labStatusMap = map;
    }

    public void setLabStatus(Lab lab, LabStatus labStatus) {
        if (!labStatusMap.containsKey(lab)) {
            throw new UnsupportedOperationException();
        } else labStatusMap.put(lab, labStatus);
    }


    public void forkLab(Lab lab) {
        labStatusMap.put(lab, LabStatus.valueOf("PENDING"));
    }

    public LabStatus getLabStatus(String labName) {
        for (Lab key : labStatusMap.keySet()) {
            if (key.getName().equals(labName)) {
                return labStatusMap.get(key);
            }
        }
        return null;
    }

    @Override
    public String toString() {
        ArrayList<String> entryList = new ArrayList<>();
        for (Lab lab : labStatusMap.keySet()) {
            entryList.add(String.format("%s > %s", lab.getName(), labStatusMap.get(lab)));
        }
        Collections.sort(entryList);
        return String.join("\n", entryList);
    }
}
