package rocks.zipcode.io.quiz3.fundamentals;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author leon on 09/12/2018.
 */
public class PigLatinGenerator {
    public String translate(String str) throws IllegalStateException {
        String[] strArray = str.split(" ");
        String[] pigLatinArray = new String[strArray.length];
        int counter = 0;
        Pattern p = Pattern.compile("[aeiou]", Pattern.CASE_INSENSITIVE);

        for (String word : strArray) {
            StringBuilder sb = new StringBuilder();
            Matcher m = p.matcher(word);
            int start = 0; // start index of word
            int firstVowel = 0;
            boolean vowelFound = false;
            try {
                vowelFound = m.find();
                firstVowel = m.start();
            } catch (IllegalStateException e) {
                //NO OP
            }
            if (start != firstVowel) { // if start is not equal to firstVowel, we caught a vowel.
                String startString = word.substring(firstVowel, word.length());
                String endString = word.substring(start, firstVowel) + "ay";
                sb.append(startString + endString);
            } else if (vowelFound == true) {
                sb.append(word + "way");
            } else sb.append(word + "ay"); //couldn't find a vowel, return original
            pigLatinArray[counter] = sb.toString();
            counter++;
        }
        return String.join(" ", pigLatinArray);
    }
}
