package rocks.zipcode.io.quiz3.generics;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.stream.Collectors;

/**
 * @author leon on 09/12/2018.
 */
public class ArrayUtility<SomeType> {
    private final SomeType[] array;

    private int dupCount;
    private SomeType dupToIgnore;

    public ArrayUtility(SomeType[] array) {
        this.array = array;
    }

    public SomeType findOddOccurringValue() {
        Arrays.sort(array);
        dupToIgnore = null;
        for (int i = 0; i < array.length; i++) {

            if (array[i]==dupToIgnore) { continue; }

            doopLoop(i);

            if (dupCount%2!=0) {
                return array[i];
            } else {
                dupToIgnore = array[i];
            }
        }
        return null;
    }

    public SomeType findEvenOccurringValue() {
        Arrays.sort(array);
        dupToIgnore = null;
        for (int i = 0; i < array.length; i++) {

            if (array[i]==dupToIgnore) { continue; }

            doopLoop(i);

            if (dupCount%2==0) {
                return array[i];
            } else {
                dupToIgnore = array[i];
            }
        }
        return null;
    }

    int doopLoop(int i) {
        dupCount = 1;
        for (int j = i+1; j < array.length; j++) {
            if (array[i] == array[j]) {
                dupCount++;
            } else {
                break;
            }
        }
        return dupCount;
    }

    public Integer getNumberOfOccurrences(SomeType valueToEvaluate) {
        Arrays.sort(array);
        dupToIgnore = null;
        for (int i = 0; i < array.length; i++) {
            if (array[i] == valueToEvaluate) {
                return doopLoop(i);
            }
        }
        return null;
    }

    public SomeType[] filter(Function<SomeType, Boolean> predicate) {
        ArrayList<SomeType> newList = new ArrayList<>();
        Arrays.stream(array).filter(someType -> predicate.apply(someType)).forEach(newList::add);
        return (SomeType[]) newList.toArray(Arrays.copyOf(this.array, newList.size()));
    }
}
